*{9}  Thu  22 Sep 1988    11:26   IBM VERSION
      PROGRAM MAIN
* Version 1.03 *********************************************************
*     INITIALIZATION
************************************************************************
        COMMON/PROPERTY/VFP,VGP,RHOF,RHOG,HFP,HGP,SFP,SGP,EFP,EGP,
     *                  VOL,TOTM,TOTH,TOTS,TOTE,X,VOID,RHO,SPECVOL,
     *                  SPECH,SPECS,SPECE,PS,TS
      COMMON/SLOPES/SRFDP,SRFDT,SRGDP,SRGDT,SHFDP,SHFDT,
     *                  SHGDP,SHGDT,G1P,G2P,G1T,G2T,F1,F2,F3,F4,F5
     *                  ,STDP,SPDT,SRDP,SRDT,SHDP,SHDT
     *                  ,SSFDP,SSFDT,SSGDP,SSGDT,SSDP,SSDT
      COMMON/TRANSPT/CPFP,CPGP,VISCFP,VISCGP,BETAFP,BETAGP,AKFP,AKGP,
     *            CP,VISC,BETA,AK,SPEEDFP,SPEEDGP,SPEED,CVFP,CVGP,
     *            CV
      COMMON/ERRORS/ERRH2O
      CHARACTER ERRH2O*70
        CHARACTER YESNO*1, ERRMSG*70
*     SET PROPERTY FLAG TO -1 TO INDICATE THAT THE STATE HAS NOT BEEN
*     DETERMINED YET.
      IFLAG=-1
*     SET THE DEFAULT SCREEN TO THE 1st SCREEN
      FLGSCR=1
************************************************************************
*     INPUT SECTION
************************************************************************
*       SETUP A SAMPLE DISPLAY
      CALL FORM1()
   5  CONTINUE
      write(*,*)' [17;1f                                              '
      write(*,*)' [18;1f                                              '
      write(*,*)' [19;1f                                              '
      write(*,*)' [20;1f                                              '
      write(*,*)' [21;1f                                              '
      write(*,*)' [22;1f                                              '
      write(*,*)' [23;1f                                              '
      write(*,*)' [24;1f                                              '
      WRITE(*,21)
  21    FORMAT(1X,'[16;1f[36mQuit, Continue, screen 1,2 or 3, Help?(Q,
     *C,1,2,3,H)[0m',/' C')
      write(*,*)' [16;1f'
      READ(*,20)YESNO
  20    FORMAT(A1)
      IF(YESNO.EQ.'Q'.OR.YESNO.EQ.'q') THEN
            WRITE(*,*)' [2J'
            STOP
      ELSEIF(YESNO.EQ.'H'.OR.YESNO.EQ.'h') THEN
            CALL HELP()
            WRITE(*,31)
  31    FORMAT(1X,'[16;1f[36m Press <RETURN> to continue............
     *          [0m')
      write(*,*)' [15;1f'
      READ(*,20)YESNO
            GOTO 5
      ELSEIF(YESNO.EQ.'1') THEN
            FLGSCR=1
            CALL FORM1()
      CALL DISP1(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)
            GOTO 5
      ELSEIF(YESNO.EQ.'2') THEN
            FLGSCR=2
            CALL FORM2()
      CALL DISP2(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)
            GOTO 5
      ELSEIF(YESNO.EQ.'3') THEN
            FLGSCR=3
            CALL FORM3()
      CALL DISP3(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)
            GOTO 5
      ENDIF
      write(*,*)' [17;1f                                              '
      WRITE(*,17)
  17  FORMAT(1X,'[16;1f','ENTER: P (MPa), T (deg C) ,VOLUME (m^3), FLAG
     *      ')
      write(*,*)' [16;1f'
      READ(*,*)P,T,VOL,ISAT
      IF (ISAT.EQ.1.OR.ISAT.EQ.2) THEN
            IFLAG=1
                write(*,*) ' [17;1f'
            WRITE(*,*)'ENTER: 0, DUMMY IF ONLY P OR T KNOWN'
            WRITE(*,*)'       1, RHO IF DENSITY KNOWN'
            WRITE(*,*)'       2, h IF SPECIFIC ENTHALPY KNOWN'
            WRITE(*,*)'       3, X IF QUALITY KNOWN'
            WRITE(*,*)'       4, VOID IF VOID KNOWN'
            READ(*,*) ITYPE,VAR
*       ASSIGN THE VARIABLE AS DIRECTED BY ITYPE
             IF (ITYPE.EQ.1) THEN
                  RHO=VAR
             ELSEIF (ITYPE.EQ.2) THEN
                  SPECH=VAR
             ELSEIF (ITYPE.EQ.3) THEN
                  X=VAR
             ELSEIF (ITYPE.EQ.4) THEN
                  VOID=VAR
            ELSE
*      SET TO 'DON'T CARE' MODE IF NOT ALREADY SET
                  ITYPE=0
            ENDIF
      ELSEIF (ISAT.EQ.3) THEN
                write(*,*) ' [17;1f'
            WRITE(*,*)'ENTER: RHO, h, tolerance, max # iter'
            READ(*,*) RHO, SPECH,ERRTOL, NMAX
      ELSEIF (ISAT.EQ.4.OR.ISAT.EQ.5) THEN
                write(*,*) ' [17;1f'
            WRITE(*,*)'ENTER: RHO, tolerance, max # iter'
            READ(*,*) RHO, ERRTOL, NMAX
      ELSEIF (ISAT.EQ.6.OR.ISAT.EQ.7) THEN
                write(*,*) ' [17;1f'
            WRITE(*,*)'ENTER:  h, tolerance, max # iter'
            READ(*,*) SPECH, ERRTOL, NMAX
      ENDIF
************************************************************************
*     CALL PROPERTIES ROUTINE
************************************************************************
      WRITE(*,*)' [24;10f[33mCALCULATING....[1m'
      CALL PROP(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG,.5)
      WRITE(*,*)' [24;10f                    '
      PS=PSAT(T)
      TS=TSAT(P)
      IF (FLGSCR.EQ.1) THEN
            CALL DISP1(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)
      ELSEIF (FLGSCR.EQ.2) THEN
            CALL DISP2(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)
      ELSEIF (FLGSCR.EQ.3) THEN
            CALL DISP3(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)
      ENDIF
      GOTO 5
      STOP
      END
************************************************************************
*     1st DISPLAY ROUTINE
************************************************************************
       SUBROUTINE DISP1(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)

        COMMON/PROPERTY/VFP,VGP,RHOF,RHOG,HFP,HGP,SFP,SGP,EFP,EGP,
     *                  VOL,TOTM,TOTH,TOTS,TOTE,X,VOID,RHO,SPECVOL,
     *                  SPECH,SPECS,SPECE,PS,TS
      COMMON/ERRORS/ERRH2O
      CHARACTER ERRH2O*70
      CHARACTER AMSG*12, ERRMSG*70
      IF (IFLAG.EQ.-1) RETURN
      IF(IFLAG.EQ.0) THEN
            AMSG='SUBCOOLED'
      ELSEIF (IFLAG.EQ.1) THEN
            AMSG='SATURATED'
      ELSEIF (IFLAG.EQ.2) THEN
            AMSG='SUPERHEATED'
      ELSE
            AMSG='UNKNOWN'
      ENDIF
        WRITE(*,2) P,T, VOL, ISAT, AMSG
    2 FORMAT(1X,'[37m[5;8f',3G14.6,I2,'  [36m  ',A12,'[37m')
      WRITE(*,8) TS,PS
    8 FORMAT (1X,'[6;9f',2G14.6)
        WRITE(*,3) RHOF,RHOG,RHO,TOTM
    3 FORMAT (1X,'[8;10f',4G14.6)
        WRITE(*,4) VFP,VGP,SPECVOL,VOL
    4 FORMAT (1X,'[9;10f',4G14.6)
        WRITE(*,5) HFP,HGP,SPECH,TOTH
    5 FORMAT (1X,'[10;10f',4G14.6,)
        WRITE(*,6) EFP,EGP,SPECE,TOTE
    6 FORMAT (1X,'[11;10f',4G14.6)
        WRITE(*,7) SFP,SGP,SPECS,TOTS
    7 FORMAT (1X,'[12;10f',4G14.6)
        WRITE(*,9)X,VOID
    9 FORMAT (1X,'[13;21f',G14.6,'[13;48f',G14.6)
        WRITE(*,10)errmsg,NMAX
   10   FORMAT(1x,'[14;1f',A70,I5)
        WRITE(*,11)errh2o
   11   FORMAT(1x,'[15;1f',A70)
       RETURN
       END
************************************************************************
*     2nd DISPLAY ROUTINE
************************************************************************
       SUBROUTINE DISP2(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)

        COMMON/PROPERTY/VFP,VGP,RHOF,RHOG,HFP,HGP,SFP,SGP,EFP,EGP,
     *                  VOL,TOTM,TOTH,TOTS,TOTE,X,VOID,RHO,SPECVOL,
     *                  SPECH,SPECS,SPECE,PS,TS
      COMMON/SLOPES/SRFDP,SRFDT,SRGDP,SRGDT,SHFDP,SHFDT,
     *                  SHGDP,SHGDT,G1P,G2P,G1T,G2T,F1,F2,F3,F4,F5
     *                  ,STDP,SPDT,SRDP,SRDT,SHDP,SHDT
     *                  ,SSFDP,SSFDT,SSGDP,SSGDT,SSDP,SSDT
      COMMON/ERRORS/ERRH2O
      CHARACTER ERRH2O*70
      CHARACTER AMSG*12, ERRMSG*70
      IF (IFLAG.EQ.-1) RETURN
      IF(IFLAG.EQ.0) THEN
            AMSG='SUBCOOLED'
      ELSEIF (IFLAG.EQ.1) THEN
            AMSG='SATURATED'
      ELSEIF (IFLAG.EQ.2) THEN
            AMSG='SUPERHEATED'
      ELSE
            AMSG='UNKNOWN'
      ENDIF
        WRITE(*,2) P,T, VOL, ISAT, AMSG
    2 FORMAT(1X,'[37m[5;8f',3G14.6,I2,'  [36m  ',A12,'[37m')
      WRITE(*,8) STDP,SPDT
    8 FORMAT (1X,'[6;9f',2G14.6)
        WRITE(*,3) SRFDP,SRGDP,SRDP
    3 FORMAT (1X,'[8;10f',3G14.6)
        WRITE(*,4) SRFDT,SRGDT,SRDT
    4 FORMAT (1X,'[9;10f',3G14.6)
        WRITE(*,5) SHFDP,SHGDP,SHDP
    5 FORMAT (1X,'[10;10f',3G14.6,)
        WRITE(*,6) SHFDT,SHGDT,SHDT
    6 FORMAT (1X,'[11;10f',3G14.6)
        WRITE(*,7) G1P,G2P,G1T,G2T
    7 FORMAT (1X,'[12;4f',G12.4,'[12;24f',G12.4,'[12;45f',G12.4,
     *  '[12;65f',G12.4)
        WRITE(*,9) F1,F2,F3
    9 FORMAT(1X,'[13;6f',G12.4,'[13;24f',G12.4,'[13;42f',G12.4)
        WRITE(*,11) F4,F5
   11 FORMAT (1X,'[15;15f',G12.4,'[15;33f',G12.4)
       RETURN
       END
************************************************************************
*     3nd DISPLAY ROUTINE
************************************************************************
       SUBROUTINE DISP3(P,T,ISAT,ITYPE,IFLAG,NMAX,ERRTOL,ERRMSG)

        COMMON/PROPERTY/VFP,VGP,RHOF,RHOG,HFP,HGP,SFP,SGP,EFP,EGP,
     *                  VOL,TOTM,TOTH,TOTS,TOTE,X,VOID,RHO,SPECVOL,
     *                  SPECH,SPECS,SPECE,PS,TS
      COMMON/SLOPES/SRFDP,SRFDT,SRGDP,SRGDT,SHFDP,SHFDT,
     *                  SHGDP,SHGDT,G1P,G2P,G1T,G2T,F1,F2,F3,F4,F5
     *                  ,STDP,SPDT,SRDP,SRDT,SHDP,SHDT
     *                  ,SSFDP,SSFDT,SSGDP,SSGDT,SSDP,SSDT
      COMMON/TRANSPT/CPFP,CPGP,VISCFP,VISCGP,BETAFP,BETAGP,AKFP,AKGP,
     *            CP,VISC,BETA,AK,SPEEDFP,SPEEDGP,SPEED,CVFP,CVGP,
     *            CV
      COMMON/ERRORS/ERRH2O
      CHARACTER ERRH2O*70
      CHARACTER AMSG*12, ERRMSG*70
      IF (IFLAG.EQ.-1) RETURN
      IF(IFLAG.EQ.0) THEN
            AMSG='SUBCOOLED'
      ELSEIF (IFLAG.EQ.1) THEN
            AMSG='SATURATED'
      ELSEIF (IFLAG.EQ.2) THEN
            AMSG='SUPERHEATED'
      ELSE
            AMSG='UNKNOWN'
      ENDIF
        WRITE(*,2) P,T, VOL, ISAT, AMSG
    2 FORMAT(1X,'[37m[5;8f',3G14.6,I2,'  [36m  ',A12,'[37m')
      WRITE(*,8) STDP,SPDT
    8 FORMAT (1X,'[6;9f',2G14.6)
        WRITE(*,3) CPFP,CPGP,CP
    3 FORMAT (1X,'[8;11f',3G14.6)
        WRITE(*,4) CVFP,CVGP,CV
    4 FORMAT (1X,'[9;11f',3G14.6)
        WRITE(*,5) VISCFP,VISCGP,VISC
    5 FORMAT (1X,'[10;11f',3G14.6)
        WRITE(*,6) BETAFP,BETAGP,BETA
    6 FORMAT (1X,'[11;11f',3G14.6,)
        WRITE(*,7) AKFP,AKGP,AK
    7 FORMAT (1X,'[12;11f',3G14.6)
        WRITE(*,9) SPEEDFP,SPEEDGP,SPEED
    9 FORMAT (1X,'[13;11f',3G14.6)
       RETURN
       END
************************************************************************
*     FORM1 DISPLAY ROUTINE
************************************************************************
       SUBROUTINE FORM1()
       WRITE(*,1)
   1   FORMAT(1X,'[2J[31m Version 1.03 
     * Screen 1 ' ,/,1X,  '[37m               M
     *cMASTER UNIVERSITY THERMALHYDRAULIC SIMULATION GROUP           ',
     */,1X,'[31m H2O PROPERTIES 
     *')
        WRITE(*,2)
    2 FORMAT(1X,'[33m           PRESSURE    TEMPERATURE   VOLUME    FLA
     *G     STATE',/)
      WRITE(*,8) 
    8 FORMAT (1X,'Tsat(P)',28X,' Psat(T)')
        WRITE(*,*)'             LIQUID PHASE   VAPOUR PHASE  INTENSIVE  
     *EXTENSIVE'
        WRITE(*,3) 
    3 FORMAT (1X,'DEN kg/m^3',56X,' kg')
        WRITE(*,4) 
    4 FORMAT (1X,'v   m^3/kg',56X,' m^3')
        WRITE(*,5) 
    5 FORMAT (1X,'h    kJ/kg',56X,' kJ')
        WRITE(*,6) 
    6 FORMAT (1X,'e    kJ/kg',56X,' kJ')
        WRITE(*,7)
    7 FORMAT (1X,'s  kJ/kg K',56X,'kJ/K')
        WRITE(*,9)
    9 FORMAT (10X,'    QUALITY',14X,'         VOID',14X)
*        WRITE(*,10)
*   10   FORMAT(' MESSAGE:',70X)
*       WRITE(*,11)
*   11  FORMAT (1X,'[31m
*     *[33m')
        write(*,15)
   15 format (1x,'[16;52f','FLAGINDEP. VAR. STATE ',
     *             '[17;52f',' 0     P & T      ?   ',
     *             '[18;52f',' 1     P         sat`d',
     *             '[19;52f',' 2     T         sat`d',
     *             '[20;52f',' 3     den. & h   ?   ',
     *             '[21;52f',' 4     den. & P   ?   ',
     *             '[22;52f',' 5     den. & T   ?   ',
     *             '[23;52f',' 6     h & P      ?   ',
     *             '[24;52f',' 7     h & T      ?   ')
       RETURN
       END
************************************************************************
*     FORM2 DISPLAY ROUTINE
************************************************************************
      SUBROUTINE FORM2()
       WRITE(*,1)
   1   FORMAT(1X,'[2J[31m Version 1.03 
     * Screen 2 ' ,/,1X,  '[37m               M
     *cMASTER UNIVERSITY THERMALHYDRAULIC SIMULATION GROUP           ',
     */,1X,'[31m H2O DERIVATIVES 
     *')
        WRITE(*,2) 
    2 FORMAT(1X,'[33m           PRESSURE    TEMPERATURE   VOLUME    FLA
     *G     STATE',/)
      WRITE(*,8) 
    8 FORMAT (1X,'DTDP    ',28X,' DPDT')
        WRITE(*,*)'             LIQUID PHASE   VAPOUR PHASE  INTENSIVE'
        WRITE(*,3) 
    3 FORMAT (1X,'dRho/dP   ',56X)
        WRITE(*,4) 
    4 FORMAT (1X,'dRho/dT   ',56X)
        WRITE(*,5) 
    5 FORMAT (1X,'dh/dP      ',56X)
        WRITE(*,6) 
    6 FORMAT (1X,'dh/dT     ',56X)
        WRITE(*,7) 
    7 FORMAT (1X,'[12;1fdP=',12X,'*dRho + ',12X,'*dh  dT=',12X,
     *  '*dRho + ',12X,'*dh')
        WRITE(*,9)
    9 FORMAT(1X,'[13;1f',17X,'*dM + ',12X,'*dH + ',12X,'*dV')
        WRITE(*,10)
   10 FORMAT (1X,'[14;1fdP =  
     *')
        WRITE(*,11)
   11 FORMAT (1X,'[15;15f',12X,'* Mg + ',12X,' * Mf')
        write(*,15)
   15 format (1x,'[16;52f','FLAGINDEP. VAR. STATE ',
     *             '[17;52f',' 0     P & T      ?   ',
     *             '[18;52f',' 1     P         sat`d',
     *             '[19;52f',' 2     T         sat`d',
     *             '[20;52f',' 3     den. & h   ?   ',
     *             '[21;52f',' 4     den. & P   ?   ',
     *             '[22;52f',' 5     den. & T   ?   ',
     *             '[23;52f',' 6     h & P      ?   ',
     *             '[24;52f',' 7     h & T      ?   ')
      RETURN
      END
************************************************************************
*     FORM3 DISPLAY ROUTINE
************************************************************************
      SUBROUTINE FORM3()
       WRITE(*,1)
   1   FORMAT(1X,'[2J[31m Version 1.03 
     * Screen 3 ' ,/,1X,  '[37m               M
     *cMASTER UNIVERSITY THERMALHYDRAULIC SIMULATION GROUP           ',
     */,1X,'[31m H2O TRANSPORT PROPERTIES 
     *')
        WRITE(*,2) 
    2 FORMAT(1X,'[33m           PRESSURE    TEMPERATURE   VOLUME    FLA
     *G     STATE',/)
      WRITE(*,8) 
    8 FORMAT (1X,'DTDP    ',28X,' DPDT')
        WRITE(*,*)'             LIQUID PHASE   VAPOUR PHASE  INTENSIVE'  
        WRITE(*,3) 
    3 FORMAT (1X,'Cp kJ/kgK',42X,' dh/dT | P')
        WRITE(*,4) 
    4 FORMAT (1X,'Cv kJ/kgK',42X,' de/dT | P')
        WRITE(*,5) 
    5 FORMAT (1X,'    kg/sm',42X,' dynamic (*10^-6)')
        WRITE(*,6) 
    6 FORMAT (1X,'    1/K ',42X,' 1/v * dv/dT | P')
        WRITE(*,7) 
    7 FORMAT (1X,'k    m^2/N',42X,'-1/v * dv/dP | T')
        WRITE(*,9) 
    9 FORMAT (1X,'c    m/s  ',42X,' speed of sound')
        write(*,15)
   15 format (1x,'[16;52f','FLAGINDEP. VAR. STATE ',
     *             '[17;52f',' 0     P & T      ?   ',
     *             '[18;52f',' 1     P         sat`d',
     *             '[19;52f',' 2     T         sat`d',
     *             '[20;52f',' 3     den. & h   ?   ',
     *             '[21;52f',' 4     den. & P   ?   ',
     *             '[22;52f',' 5     den. & T   ?   ',
     *             '[23;52f',' 6     h & P      ?   ',
     *             '[24;52f',' 7     h & T      ?   ')
      RETURN
      END

************************************************************************
*     DISPLAY HELP ROUTINE
************************************************************************
      SUBROUTINE HELP()
      WRITE (*,*) ' [17;1f HELP:                                '
      WRITE (*,*) ' [18;5fThis program calculates H2O properties'
      WRITE (*,*) ' [19;5fas a function of the independent      '
      WRITE (*,*) ' [20;5fvariables shown on the right. Just    '
      WRITE (*,*) ' [21;5ffollow the prompts. Remember: GIGO    '
      WRITE (*,*) ' [22;5f- Garbage In - Garbage Out ! The input'
      WRITE (*,*) ' [23;5fvariables must represent feasible states.'
      return 
      end
